/* ------ */
/* MODIFY THIS SECTION IF USING STK VERSION < 1.1 */
/* Be aware that this will ruin online play for this add-on. This section makes sure 
     all players get the same course layout in a race, but necessary script functions
     only work from STK 1.1 onwards */

/* If using STK version < 1.1, remove this next line */
int seed = Track::getItemManagerRandomSeed(); // seed is a uint but we don't need its actual value

/* If using STK version < 1.1, remove all lines between:
     "int getRandomNumber(int upper_range){ "
        until
     "return Utils::randomInt(0, upper_range); " 
     NOT including those lines */

/* Modified code by Gumball but this one works for 6 and coefficients are better for 6 */
int getRandomNumber(int upper_range){
    if (Utils::isNetworking()) {
        int x = seed % 6;
        seed = seed / 6;
        /* Extend seed if we are about to run out of values */
        if (seed < 36) { seed = (seed + 1) * 41119;}
        return x % upper_range;
    }
    return Utils::randomInt(0, upper_range);
}

/* END SECTION */

int ran = getRandomNumber(6);

void warpKart(int idKart, const string libraryInstance, const string obj_id) {
	Vec3 position;

	switch (ran) {
		case 0:
			position = Track::getTrackObject("", "warp1B").getCenterPosition();
	        Kart::teleportExact(idKart, position);
			break;
		case 1:
			position = Track::getTrackObject("", "warp1R").getCenterPosition();
	        Kart::teleportExact(idKart, position);
			break;
		case 2:
			position = Track::getTrackObject("", "warp2B").getCenterPosition();
	        Kart::teleportExact(idKart, position);
			break;
		case 3:
			position = Track::getTrackObject("", "warp2R").getCenterPosition();
	        Kart::teleportExact(idKart, position);
			break;
		case 4:
			position = Track::getTrackObject("", "warp3B").getCenterPosition();
	        Kart::teleportExact(idKart, position);
			break;
		case 5: default:
			position = Track::getTrackObject("", "warp3R").getCenterPosition();
	        Kart::teleportExact(idKart, position);
	}

	ran = getRandomNumber(6);
}
